VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clUPnP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Copyright (C) 2008 takuya
'License: GPL v2 or later (read "LICENSE")
'̃R[h̃CZX́AGPL v2܂͂ȍ~łB

Option Explicit

'clUPnP.cls - UPnPfoCX擾E|[gJNX
'[v]
'EtimeGetTimeSleep API`Ă
'EclUPnP(SETUNSET̊)gp\WinsockRg[pӂĂ
'E]łȂ

Const UPNP_ERR_GETIPADDRESSFAULT            As Long = 1001
Const UPNP_ERR_GETUPNPDEVICEFAULT           As Long = 1002
Const UPNP_ERR_GETUPNPCONTROLADDRESSFAULT   As Long = 1003
Const UPNP_ERR_ENTRYNOTFOUND                As Long = 1004
Const UPNP_ERR_ENTRYEXIST                   As Long = 1005
Const UPNP_ERR_NODEFINE                     As Long = 1999

Const UPNPc_ERR_UPNPDEVICENOTFOUND          As Long = 20101
Const UPNPc_ERR_CONNECTERROR                As Long = 20201
Const UPNPc_ERR_UPNPCONTROLPOINTNOTFOUND    As Long = 20301
Const UPNPc_ERR_UPNPACTIONERROR             As Long = 20401

Private Enum eState
    SSDP_Search = 11&
    SSDP_Found = 12&
    SOAP_URLSearch = 21&
    SOAP_URLWait = 22&
    SOAP_Ready = 31&
    SOAP_Wait = 32&
    SOAP_Receive = 33&
    SOAP_Error = 39&
End Enum
Public Enum eUPnP_Device
    WAN_IPDevice = 11&
    WAN_PPPDevice = 12&
End Enum
Private Type tUPnP_Device
    friendlyName     As String
    manufacturer     As String
    modelName        As String
    modelDescription As String
End Type

Public WithEvents oTCPSock As Winsock
Attribute oTCPSock.VB_VarHelpID = -1
Public WithEvents oUDPSock As Winsock
Attribute oUDPSock.VB_VarHelpID = -1
Dim sIPAddress As String, iState As eState
'UDP\Pbgp
Dim sUBuffer As String
'TCP\Pbgp
Dim sTBuffer As String, iExceptLength As Long

'evpeB
Dim p_sURL_Desc As String, p_sURL_Control As String, p_tDeviceType As eUPnP_Device, p_uUPnP_Device As tUPnP_Device, p_sDescription As String

Property Get Ready() As Boolean
    If iState = SOAP_Ready Then Ready = True Else Ready = False
End Property
Property Get URL_Desc() As String
    URL_Desc = p_sURL_Desc
End Property
Property Get URL_Control() As String
    URL_Control = p_sURL_Control
End Property
Property Get DeviceType() As eUPnP_Device
    DeviceType = p_tDeviceType
End Property
Property Get DeviceName() As String
    If p_uUPnP_Device.friendlyName <> "" Then
        DeviceName = p_uUPnP_Device.friendlyName
    Else
        DeviceName = p_uUPnP_Device.modelName
    End If
End Property
Property Let Description(sDescription As String)
    p_sDescription = sDescription
End Property

Public Sub SET_SockObject(oSTCPSock As Winsock, oSUDPSock As Winsock)
    Set oTCPSock = oSTCPSock: Set oUDPSock = oSUDPSock
    If oTCPSock.State <> sckClosed Then oTCPSock.Close
    If oUDPSock.State <> sckClosed Then oUDPSock.Close
    oTCPSock.Protocol = sckTCPProtocol: oUDPSock.Protocol = sckUDPProtocol
    sUBuffer = "": sTBuffer = ""
End Sub

Public Sub UNSET_SockObject()
    Set oTCPSock = Nothing: Set oUDPSock = Nothing
End Sub

Public Function Detect(Optional ByVal sIPAddr As String = "") As Long
    On Error GoTo RAISE_ERR
    Detect = -1
    
    'C^[lbg֐ڑ\IPAhXo
    If sIPAddr = "" Then sIPAddress = Get_IPAddress Else sIPAddress = sIPAddr
    If sIPAddress = "" Then Detect = UPNP_ERR_GETIPADDRESSFAULT: Exit Function
    
    'SSDP(TTL̐ݒ͐Ȃ)păfoCX̌v
    If Get_UPnPDevice(sIPAddress) <> 0 Then Detect = UPNP_ERR_GETUPNPDEVICEFAULT: Exit Function

    'UPnPfoCX̏擾Ă
    If Get_UPnPDeviceInfo(Me.URL_Desc) <> 0 Then Detect = UPNP_ERR_GETUPNPCONTROLADDRESSFAULT: Exit Function
    
    Detect = 0
    Exit Function
RAISE_ERR:
    Debug.Print "װ" & Err.Number & ":" & Err.Description & "(by " & Err.Source & ")"
    Detect = UPNP_ERR_NODEFINE
End Function

Public Function OpenPort(ByVal iDevicePort As Long, Optional ByVal iComputerPort As Long = -1, Optional ByVal sForwardIPAddress As String = "", Optional ByVal sDescription As String = "") As Long
    If sForwardIPAddress = "" Then sForwardIPAddress = sIPAddress
    If iComputerPort = -1 Then iComputerPort = iDevicePort
    If sDescription = "" Then sDescription = p_sDescription
    If sDescription = "" Then sDescription = "UPnPVB"
    
    If PortMapping_Exist(iDevicePort) = 1 Then
        If PortMapping_Exist(iDevicePort, sDescription) = 0 Then
            OpenPort = UPNP_ERR_ENTRYEXIST
        Else
            Call ClosePort(iDevicePort, sDescription)
            Debug.Print "|[g܂"
        End If
    End If
    
    Debug.Print "|[gJ܂"
    OpenPort = Set_WANDevice("AddPortMapping", _
    "<NewRemoteHost xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""string""></NewRemoteHost>" & _
    "<NewExternalPort xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""ui2"">" & iDevicePort & "</NewExternalPort>" & _
    "<NewProtocol xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""string"">" & "TCP" & "</NewProtocol>" & _
    "<NewInternalPort xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""ui2"">" & iComputerPort & "</NewInternalPort>" & _
    "<NewInternalClient xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""string"">" & sForwardIPAddress & "</NewInternalClient>" & _
    "<NewEnabled xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""boolean"">1</NewEnabled>" & _
    "<NewPortMappingDescription xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""string"">" & sDescription & "</NewPortMappingDescription>" & _
    "<NewLeaseDuration xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""ui4"">0</NewLeaseDuration>")
End Function

Public Function ClosePort(ByVal iDevicePort As Long, Optional ByVal sDescription As String = "") As Long
    If sDescription = "" Then sDescription = p_sDescription
    If sDescription = "" Then sDescription = "UPnPVB"
    
    If PortMapping_Exist(iDevicePort, sDescription) = 0 Then ClosePort = UPNP_ERR_ENTRYNOTFOUND: Exit Function
    Debug.Print "|[g܂"
    ClosePort = Set_WANDevice("DeletePortMapping", _
    "<NewRemoteHost xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""string""></NewRemoteHost>" & _
    "<NewExternalPort xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""ui2"">" & iDevicePort & "</NewExternalPort>" & _
    "<NewProtocol xmlns:dt=""urn:schemas-microsoft-com:datatypes"" dt:dt=""string"">" & "TCP" & "</NewProtocol>")
End Function

Private Function PortMapping_Exist(ByVal iDevicePort As Long, Optional ByVal sDescription As String = "") As Long
    '݂ĂȂ=0 ݂Ă=1(0ȊO)
    Dim i As Long, sReturn As String
    For i = 0 To 127
        sReturn = "all"
        If Set_WANDevice("GetGenericPortMappingEntry", "<NewPortMappingIndex>" & i & "</NewPortMappingIndex>", sReturn) <> 0 Then Exit For
        If (iDevicePort = Get_XMLColumn(sReturn, "newexternalport")) And ((sDescription = "") Or (sDescription = Get_XMLColumn(sReturn, "newportmappingdescription"))) Then PortMapping_Exist = 1
    Next
End Function

Public Sub PortList()
    Dim i As Long, sReturn As String
    For i = 0 To 100
        sReturn = "all"
        If Set_WANDevice("GetGenericPortMappingEntry", "<NewPortMappingIndex>" & i & "</NewPortMappingIndex>", sReturn) <> 0 Then Exit For
        Debug.Print i & "̃|[g}bsO:" & sReturn
    Next
End Sub

Private Function Get_UPnPDevice(ByVal sIPv4Address As String) As Long
With oUDPSock
    On Error GoTo Get_Error
    Dim lTime As Long
    If .State <> sckClosed Then .Close
    iState = SSDP_Search
    .Bind 15001, sIPv4Address: .RemoteHost = "239.255.255.250": .RemotePort = 1900: DoEvents
    .SendData "M-SEARCH * HTTP/1.1" & vbCrLf & _
              "MX: 3" & vbCrLf & _
              "HOST: 239.255.255.250:1900" & vbCrLf & _
              "MAN: ""ssdp:discover""" & vbCrLf & _
              "ST: urn:schemas-upnp-org:service:WANPPPConnection:1" & vbCrLf & vbCrLf
    .SendData "M-SEARCH * HTTP/1.1" & vbCrLf & _
              "MX: 3" & vbCrLf & _
              "HOST: 239.255.255.250:1900" & vbCrLf & _
              "MAN: ""ssdp:discover""" & vbCrLf & _
              "ST: urn:schemas-upnp-org:service:WANIPConnection:1" & vbCrLf & vbCrLf
    lTime = timeGetTime
    Do
        If (timeGetTime - lTime) > 3000 Then Exit Do
        Sleep 20: DoEvents
    Loop Until iState <> SSDP_Search
    
    .Close
    
    If iState = SSDP_Search Then
        'UPnPfoCX͌܂łB
        Get_UPnPDevice = UPNPc_ERR_UPNPDEVICENOTFOUND
    Else
        'UPnPfoCX܂B
        Get_UPnPDevice = 0
    End If
End With
    Exit Function
Get_Error:
    Get_UPnPDevice = UPNP_ERR_NODEFINE
End Function

Private Function Get_UPnPDeviceInfo(ByVal sLocation As String) As Long
    'TCP\PbgŃfoCXERg[URLQbgI
    On Error GoTo Get_UPnPDeviceInfoError
With oTCPSock
    Dim sServer As String, iPort As Long, sPath As String, lTime As Long
    iState = SOAP_URLSearch
    Get_HTTPAddress Me.URL_Desc, sServer, iPort, sPath
    
    'wURLɐڑA擾
    If wTCP_TryConnect(sServer, iPort) <> 0 Then Get_UPnPDeviceInfo = UPNPc_ERR_CONNECTERROR: Exit Function
    oTCPSock.SendData _
    "GET " & sPath & " HTTP/1.1" & vbCrLf & _
    "Host: " & sServer & ":" & iPort & vbCrLf & vbCrLf
    
    lTime = timeGetTime
    Do
        Sleep 20: DoEvents
        If (timeGetTime - lTime) > 3000 Then Exit Do
    Loop Until iState = SOAP_Ready
    
    If iState = SOAP_Ready Then
        '܂
        Get_UPnPDeviceInfo = 0
    Else
        '܂ł
        Get_UPnPDeviceInfo = UPNPc_ERR_UPNPCONTROLPOINTNOTFOUND
    End If
End With
    Exit Function
Get_UPnPDeviceInfoError:
    Debug.Print "װ" & Err.Number & ":" & Err.Description & "(by " & Err.Source & ")"
    Get_UPnPDeviceInfo = UPNP_ERR_NODEFINE
End Function

Private Function Get_IPAddress() As String
    Dim lTime As Long, bOK As Byte

    If oTCPSock.State <> sckClosed Then oTCPSock.Close
    oTCPSock.LocalPort = 0: lTime = timeGetTime
    oTCPSock.Connect "p2pquake.ddo.jp", 80
    Do
        If oTCPSock.State = 7 Then bOK = 1: Exit Do
        Sleep 20: DoEvents
    Loop Until (timeGetTime - lTime) > 3000
    
    If bOK = 1 Then Get_IPAddress = oTCPSock.LocalIP
    
    oTCPSock.Close
End Function

Private Sub oTCPSock_DataArrival(ByVal bytesTotal As Long)
    Dim sBuffer As String
    oTCPSock.GetData sBuffer, vbString
    sTBuffer = sTBuffer & sBuffer
    If iState = SOAP_URLSearch Then Check_SimplyHTTP sTBuffer, 2
    If iState = SOAP_Wait Then Check_SimplyHTTP sTBuffer, 2
    If (iState = SOAP_URLWait) Or (iState = SOAP_Receive) Then
        If Len(sTBuffer) >= iExceptLength Then
            If iState = SOAP_URLWait Then Set_UPnPDeviceInfo sTBuffer
            If iState = SOAP_Receive Then
                If Get_XMLColumn(sTBuffer, "errorcode") = "-1" Then iState = SOAP_Ready Else iState = SOAP_Error
            End If
        End If
    End If
End Sub

Private Sub Set_UPnPDeviceInfo(ByVal sXML As String)
    'foCX擾
    p_uUPnP_Device.friendlyName = Get_XMLColumn(sXML, "friendlyname")
    p_uUPnP_Device.manufacturer = Get_XMLColumn(sXML, "manufacturer")
    p_uUPnP_Device.modelName = Get_XMLColumn(sXML, "modelname")
    p_uUPnP_Device.modelDescription = Get_XMLColumn(sXML, "modeldescription")
    If Me.DeviceType = WAN_IPDevice Then
        p_sURL_Control = Get_XMLColumn(sXML, "controlurl", "WANIPConnection")
    ElseIf Me.DeviceType = WAN_PPPDevice Then
        p_sURL_Control = Get_XMLColumn(sXML, "controlurl", "WANPPPConnection")
    End If
    iState = SOAP_Ready
End Sub

Private Sub oUDPSock_DataArrival(ByVal bytesTotal As Long)
    Dim sBuffer As String
    oUDPSock.GetData sBuffer, vbString
    sUBuffer = sUBuffer & sBuffer
     Check_SimplyHTTP sUBuffer, 1
End Sub

Private Sub Check_SimplyHTTP(ByRef sCheckBuffer As String, ByVal iCase As Long)
    Dim lOffset As Long, sSimplyHTTP As String
    Do
        lOffset = InStr(1, sCheckBuffer, vbCrLf & vbCrLf)
        If lOffset = 0 Then Exit Do
        sSimplyHTTP = Left$(sCheckBuffer, lOffset): sCheckBuffer = Mid$(sCheckBuffer, lOffset + 2)
        
        Select Case iCase
        Case 1
            If iState = SSDP_Search Then
                'Locationwb_Ύ擾Found
                p_sURL_Desc = Get_HTTPHeaderColumn(sSimplyHTTP, "Location")
                If InStr(1, sSimplyHTTP, "WANIP") <> 0 Then p_tDeviceType = WAN_IPDevice Else p_tDeviceType = WAN_PPPDevice
                If p_sURL_Desc <> "-1" Then iState = SSDP_Found
            End If
        Case 2
            If (iState = SOAP_URLSearch) Or (iState = SOAP_Wait) Then
                'Content-lengthwb_ȂƎn܂Ȃ
                iExceptLength = Get_HTTPHeaderColumn(sSimplyHTTP, "Content-length")
                If iState = SOAP_URLSearch Then iState = SOAP_URLWait
                If iState = SOAP_Wait Then iState = SOAP_Receive
                Exit Do
            End If
        End Select
    Loop
End Sub

Private Function Get_HTTPHeaderColumn(ByVal sHTTPHeader As String, ByVal sGetColumn As String) As String
    On Error GoTo Get_HTTPHeaderColumnError

    Dim lOffset As Long
    lOffset = InStr(1, LCase(sHTTPHeader), LCase(sGetColumn) & ":") + Len(sGetColumn) + 1
    If lOffset = Len(sGetColumn) + 1 Then Get_HTTPHeaderColumn = -1: Exit Function
    If Mid$(sHTTPHeader, lOffset, 1) = " " Then lOffset = lOffset + 1
    Get_HTTPHeaderColumn = Mid$(sHTTPHeader, lOffset, InStr(lOffset, sHTTPHeader, vbCrLf) - lOffset)
    
    Exit Function
Get_HTTPHeaderColumnError:
    Get_HTTPHeaderColumn = -1
End Function

Private Sub Get_HTTPAddress(ByVal sAddress As String, ByRef sCServer As String, ByRef lCPort As Long, ByRef sCPath As String)
    Dim lOffset As Long, l2Offset As Long
    sAddress = Mid$(sAddress, 8)
    lOffset = InStr(1, sAddress, ":") + 1
    l2Offset = InStr(1, sAddress, "/")
    
    If lOffset = 1 Then '|[g̓ftH
        lCPort = 80: sCServer = Left$(sAddress, l2Offset - 1)
    Else                '|[g
        sCServer = Left$(sAddress, lOffset - 2): lCPort = Mid(sAddress, lOffset, l2Offset - lOffset)
    End If
    
    sCPath = Mid$(sAddress, l2Offset)
End Sub

Private Function wTCP_TryConnect(ByVal sServer As String, ByVal lPort As Long) As Long
    Dim iTime As Long
    wTCP_TryConnect = -1: sTBuffer = ""
    If oTCPSock.State <> sckClosed Then oTCPSock.Close
    oTCPSock.LocalPort = 0: iTime = timeGetTime
    oTCPSock.Connect sServer, lPort
    
    Do
        Sleep 10: DoEvents
        If oTCPSock.State = sckConnected Then wTCP_TryConnect = 0: Exit Do
    Loop Until (timeGetTime - iTime) > 3000
End Function

Private Function Get_XMLColumn(ByVal sXMLData As String, sXMLColumn As String, Optional sOffset As String = "") As String
    Dim lOffset As Long
    If sOffset <> "" Then
        lOffset = InStr(1, sXMLData, sOffset)
        If lOffset <> 0 Then sXMLData = Mid$(sXMLData, lOffset)
    End If
    
    lOffset = InStr(1, LCase(sXMLData), "<" & sXMLColumn & ">") + Len(sXMLColumn) + 2
    If lOffset <> Len(sXMLColumn) + 2 Then
        Get_XMLColumn = Mid$(sXMLData, lOffset, InStr(lOffset, LCase(sXMLData), "</" & sXMLColumn & ">") - lOffset)
    Else
        Get_XMLColumn = -1
    End If
End Function

Private Function Set_WANDevice(ByVal sAction As String, Optional ByVal sOption As String = "", Optional ByRef sReturn As String = "") As Long
    Dim sServer As String, iPort As Long, sPath As String, lTime As Long
    Dim sHeader As String, sContent As String, sType As String
    Get_HTTPAddress p_sURL_Desc, sServer, iPort, sPath: sPath = p_sURL_Control
    
    If wTCP_TryConnect(sServer, iPort) <> 0 Then Set_WANDevice = UPNPc_ERR_CONNECTERROR: Exit Function
    iState = SOAP_Wait
    
    '肾
    If p_tDeviceType = WAN_IPDevice Then sType = "WANIPConnection" Else sType = "WANPPPConnection"
    
    sHeader = _
    "POST " & sPath & " HTTP/1.1" & vbCrLf & _
    "Content-type: text/xml; charset=""utf-8""" & vbCrLf & _
    "SOAPAction: ""urn:schemas-upnp-org:service:" & sType & ":1#" & sAction & """" & vbCrLf & _
    "User-Agent: Mozilla/4.0 (compatible; UPnP/1.0; Windows 9x)" & vbCrLf & _
    "Host: " & sServer & ":" & iPort & vbCrLf & _
    "Content-Length: "
    
    sContent = _
    "<?xml version=""1.0""?>" & vbCrLf & _
    "<SOAP-ENV:Envelope xmlns:SOAP-ENV=""http://schemas.xmlsoap.org/soap/envelope/"" SOAP-ENV:encodingStyle=""http://schemas.xmlsoap.org/soap/encoding/"">" & vbCrLf & _
    "<SOAP-ENV:Body>" & vbCrLf & _
    "<m:" & sAction & " xmlns:m=""urn:schemas-upnp-org:service:" & sType & ":1"">" & vbCrLf & _
    sOption & "</m:" & sAction & ">" & vbCrLf & _
    "</SOAP-ENV:Body>" & vbCrLf & _
    "</SOAP-ENV:Envelope>" & vbCrLf

    sHeader = sHeader & Len(sContent) & vbCrLf & _
                "Pragma: no-cache" & vbCrLf & vbCrLf
                
    oTCPSock.SendData sHeader & sContent
    
    lTime = timeGetTime
    Do
        Sleep 20: DoEvents
        If (timeGetTime - lTime) > 3000 Then Exit Do
    Loop Until (iState = SOAP_Ready) Or (iState = SOAP_Error)
    
    If iState = SOAP_Ready Then
        '܂
        Set_WANDevice = 0
        If sReturn = "all" Then
            sReturn = sTBuffer
        ElseIf sReturn <> "" Then
            sReturn = Get_XMLColumn(sTBuffer, sReturn)
        End If
    Else
        's܂
        Set_WANDevice = UPNPc_ERR_UPNPACTIONERROR
        iState = SOAP_Ready
    End If
End Function

