Attribute VB_Name = "mVBCrypt"
'Copyright (C) 2008 takuya
'License: GPL v2 or later (read "LICENSE")
'̃R[h̃CZX́AGPL v2܂͂ȍ~łB

Option Explicit

'mVBCrypt.bas--
'̌؃W[

Public Declare Function RSASSA_PKCS1v15_Signer_SignatureLength Lib "vbcrypt2.dll" (ByVal lpPrivateKey As String, ByVal nHash As Long) As Long
Private Declare Function RSASSA_PKCS1v15_SignText Lib "vbcrypt2.dll" (ByRef retSign As Byte, ByRef bSource As Byte, ByVal lSourceLen As Long, ByVal sPrivateKey As String, ByVal sRandomSeed As String, ByVal lRSeedLen As Long, ByVal nHashType As Long) As Long
Private Declare Function RSASSA_PKCS1v15_VerifyText Lib "vbcrypt2.dll" (ByRef bSign As Byte, ByVal lSignLen As Long, ByRef bSource As Byte, ByVal lSourceLen As Long, ByVal sPublicKey As String, ByVal nHashType As Long) As Long
Public Declare Sub MD5_Generate Lib "vbcrypt2.dll" (ByRef lpDest As Byte, ByVal lpSource As String, ByVal lpSourceLen As Long)
Public Declare Sub MD5_BinaryGenerate Lib "vbcrypt2.dll" Alias "MD5_Generate" (ByRef lpDest As Byte, ByRef lpSource As Byte, ByVal lpSourceLen As Long)
Private Declare Function BASE64_DecryptText Lib "vbcrypt2.dll" (ByRef lpDest As Byte, ByVal lDestLen As Long, ByVal lpSource As String, ByVal lpSourceLen As Long) As Long
Public Declare Sub BASE64_EncryptText Lib "vbcrypt2.dll" (ByVal retStr As String, ByVal lretLen As Long, ByRef bSource As Byte, ByVal lSourceLen As Long)

Private Const sServerVerifyKey As String = "MIGdMA0GCSqGSIb3DQEBAQUAA4GLADCBhwKBgQC8p/vth2yb/k9x2/PcXKdb6oI3gAbhvr/HPTOwla5tQHB83LXNF4Y+Sv/Mu4Uu0tKWz02FrLgA5cuJZfba9QNULTZLTNUgUXIB0m/dq5Rx17IyCfLQ2XngmfFkfnRdRSK7kGnIXvO2/LOKD50JsTf2vz0RQIdw6cEmdl+Aga7i8QIBEQ=="
Private Const sPeerVerifyKey As String = "MIGdMA0GCSqGSIb3DQEBAQUAA4GLADCBhwKBgQDJzl35eIicJMm+wm6jkzsSQwwg++2azeI74GcWVEOvosUTLNYnP02/LcM6HG+QhsCMvc+iNZZLS7MG/mTgv0iv/63Db+v8Xdrbw4EXbxYezoMUfVXLhaQzpU32teo+5NzePmECN0xD54nDbsYxBHfuS/n/Ws8DBDE/9D/SFv24lwIBEQ=="

'̌---------------------------------------------------------------------
Public Function ServerData_Verify(sB64Signature As String, sVerifyExpire As String, sVerifyText As String, bNoVerifing As Byte) As Long
  Dim bSignature(127) As Byte, lVerify As Long, vVerifyText As Variant, dExpire As Date
  Dim bMD5(15) As Byte, bDate() As Byte, bVerifyData() As Byte

  dExpire = Replace(sVerifyExpire, "-", ":")
  logger "x`}[NX^[g1i" & Benchmark_Diff & "msj", Debug_Lv
  logger "x`}[NX^[g2i" & Benchmark_Diff & "msj", Debug_Lv
  
  '܂͗L---------------------------------------------------------
  If DateDiff("n", Protocol_Now, dExpire) < 0 Then
    logger "f[^̗L؂ł", Warn_Lv
    Exit Function
  Else
    logger "Li" & Benchmark_Diff & "msj", Debug_Lv
  End If
  
  '̌邩ǂ`FbN---------------------------------------------
  If bNoVerifing = 1 Then ServerData_Verify = 1: Exit Function
    
  'BASE64fR[hisIj---------------------------------------------
  If BASE64_DecryptText(bSignature(0), 128, sB64Signature, Len(sB64Signature)) = -1 Then
    logger "BASE64fR[hɎs܂", Caut_Lv
    Exit Function
  Else
    logger "BASE64fR[hi" & Benchmark_Diff & "msj", Debug_Lv
  End If
  
  '-------------------------------------------------------------------
  vVerifyText = StrConv(sVerifyText, vbFromUnicode)
  MD5_Generate bMD5(0), sVerifyText, LenB(vVerifyText)
  vVerifyText = ""
  logger "f[^nbV쐬i" & Benchmark_Diff & "msj", Debug_Lv
  bDate() = StrConv(sVerifyExpire, vbFromUnicode)
  vbc_BinaryJoint bDate(), bMD5(), bVerifyData()
  logger "f[^̌i" & Benchmark_Diff & "msj", Debug_Lv
  
  lVerify = RSASSA_PKCS1v15_VerifyText(bSignature(0), 128, bVerifyData(0), UBound(bVerifyData) + 1, sServerVerifyKey, 3)
  If lVerify <> 0 Then logger "؂ɐ܂i" & Benchmark_Diff & "ms/Total:" & Benchmark_End & "msj", Debug_Lv Else logger "؂Ɏs܂", Caut_Lv
  
  ServerData_Verify = lVerify
End Function

'̌؁i[U[j---------------------------------------------------------
Public Function UserData_Verify(sPublicKey As String, sKeySignature As String, sKeyExpire As String, sB64Signature As String, sVerifyExpire As String, sVerifyText As String, bNoVerifing As Byte) As Long
  Dim bKeySignature(127) As Byte, bKey() As Byte, bDataSignature(47) As Byte, dExpire As Date, lVerify As Long, vVerifyText As Variant, bCheck() As Byte
  Dim bTrashBinary() As Byte, bSrcMD5(15) As Byte
  dExpire = Replace(sVerifyExpire, "-", ":")
  Benchmark_Start
  logger "x`}[NX^[g1i" & Benchmark_Diff & "msj", Debug_Lv
  logger "x`}[NX^[g2i" & Benchmark_Diff & "msj", Debug_Lv
  
  'f[^̗L`FbN-------------------------------------------
  If DateDiff("n", Protocol_Now, dExpire) < 0 Then logger "f[^̗L؂ł", Warn_Lv: Exit Function
  logger "Li" & Benchmark_Diff & "msj", Debug_Lv
  
  '̌邩ǂ`FbN---------------------------------------------
  If bNoVerifing = 1 Then UserData_Verify = 1: Exit Function
  
  dExpire = Replace(sKeyExpire, "-", ":")
  If DateDiff("n", Protocol_Now, dExpire) < 0 Then logger "̗L؂ł", Warn_Lv: Exit Function
  
  '-------------------------------------------------------------
  If BASE64_DecryptText(bKeySignature(0), 128, sKeySignature, Len(sKeySignature)) = -1 Then logger "BASE64fR[hɎs܂", Caut_Lv: Exit Function
  
  Dim lret As Long
  ReDim bKey(110) As Byte
  lret = BASE64_DecryptText(bKey(0), 111, sPublicKey, Len(sPublicKey))
  ReDim Preserve bKey(lret - 1) As Byte
  If lret = -1 Then logger "BASE64fR[hɎs܂", Caut_Lv: Exit Function
  logger "BASE64fR[hi" & Benchmark_Diff & "msj", Debug_Lv
  
  'Debug.Print "BASE64vbc:" & vbc_BASE64Hash(sPublicKey, bKey(), bTrashBinary())
  vbc_BinaryJoint bKey(), StrConv(sKeyExpire, vbFromUnicode), bCheck()

#If developmode = 2 Then
        Dim i As Long, sTemp As String
        For i = 0 To UBound(bCheck)
          If bCheck(i) < 16 Then sTemp = sTemp & "0" & Hex(bCheck(i)) Else sTemp = sTemp & Hex(bCheck(i))
        Next
        logger "؂ׂF" & sTemp, Debug_Lv
        sTemp = ""
        For i = 0 To UBound(bKeySignature)
          If bKeySignature(i) < 16 Then sTemp = sTemp & "0" & Hex(bKeySignature(i)) Else sTemp = sTemp & Hex(bKeySignature(i))
        Next
        logger "؂ׂ(B64:" & sKeySignature & ")F" & sTemp, Debug_Lv
        logger "؂ׂF" & sPublicKey, Debug_Lv
#End If
  
  lVerify = RSASSA_PKCS1v15_VerifyText(bKeySignature(0), 128, bCheck(0), UBound(bCheck) + 1, sPeerVerifyKey, 3)
  If lVerify = 0 Then logger "̌؎s", Caut_Lv: Exit Function
  logger "̌ؐi" & Benchmark_Diff & "msj", Debug_Lv
  
  'f[^---------------------------------------------------------
  Debug.Print sB64Signature
  If BASE64_DecryptText(bDataSignature(0), 48, sB64Signature, Len(sB64Signature)) = -1 Then logger "BASE64fR[hɎs܂", Caut_Lv: Exit Function
  logger "BASE64fR[hi" & Benchmark_Diff & "msj", Debug_Lv
  
  vVerifyText = StrConv(sVerifyText, vbFromUnicode)
  MD5_Generate bSrcMD5(0), sVerifyText, LenB(vVerifyText)
  vVerifyText = ""
  bCheck() = StrConv(sVerifyExpire, vbFromUnicode)
  vbc_BinaryJoint bCheck(), bSrcMD5(), bCheck()
  
  'logger "؂̂āF" & sVerifyExpire & sVerifyText & "", Debug_Lv
#If developmode = 1 Then
  Dim bbTime As Long
  bbTime = timeGetTime
#End If
  lVerify = RSASSA_PKCS1v15_VerifyText(bDataSignature(0), 48, bCheck(0), UBound(bCheck) + 1, sPublicKey, 3)
#If developmode = 1 Then
  logger "؎ԁF" & timeGetTime - bbTime & "ms", Debug_Lv
#End If
  If lVerify = 0 Then logger "f[^̌؎s", Caut_Lv Else logger "f[^̌ؐi" & Benchmark_Diff & "msj", Debug_Lv
  
  UserData_Verify = lVerify
End Function

'-----------------------------------------------------------------------
Public Function UserData_Sign(sSignData As String, ByRef sRetSignData As String) As String
  Dim sExpire As String, kVariant As Variant, bSign(47) As Byte, sRandom As String, sB64 As String
  Dim bDestSign() As Byte, bDestMD5(15) As Byte
  
  sExpire = Format$(DateAdd("n", 1, Protocol_Now), "yyyy/mm/dd hh-nn-ss")
  If uKeyData.sPrivateKey = "Unknown" Then sRetSignData = Generate_Random: UserData_Sign = sRetSignData & ":" & sExpire: Exit Function
  sRandom = lPeerID & sExpire & Generate_Random

  'logger "̂āF" & sExpire & sSignData & "", Debug_Lv
  kVariant = StrConv(sSignData, vbFromUnicode)
  MD5_Generate bDestMD5(0), sSignData, LenB(kVariant)
  kVariant = ""
  bDestSign() = StrConv(sExpire, vbFromUnicode)
  vbc_BinaryJoint bDestSign(), bDestMD5(), bDestSign()

#If developmode = 1 Then
  Dim bbTime As Long
  bbTime = timeGetTime

#End If
  Call RSASSA_PKCS1v15_SignText(bSign(0), bDestSign(0), UBound(bDestSign) + 1, uKeyData.sPrivateKey, sRandom, Len(sRandom), 3)
#If developmode = 1 Then
  logger "؎ԁF" & timeGetTime - bbTime & "ms", Debug_Lv

#End If
  sB64 = String$(256, Chr$(0))
  

#If developmode = 2 Then
        Dim i As Long, sTemp As String, kv() As Byte
        kv() = StrConv(sExpire & sSignData, vbFromUnicode)
        For i = 0 To UBound(kv)
          If kv(i) < 16 Then sTemp = sTemp & "0" & Hex(kv(i)) Else sTemp = sTemp & Hex(kv(i))
        Next
        logger "f[^؂ׂF" & sTemp, Debug_Lv
#End If
  
  
  BASE64_EncryptText sB64, 256, bSign(0), 48
  vbc_BlankDelete sB64
  
  
#If developmode = 2 Then
        sTemp = ""
        For i = 0 To UBound(bSign)
          If bSign(i) < 16 Then sTemp = sTemp & "0" & Hex(bSign(i)) Else sTemp = sTemp & Hex(bSign(i))
        Next
        logger "f[^؂ׂ(B64:" & sB64 & ")F" & sTemp, Debug_Lv
#End If
  
  sRetSignData = sB64
  UserData_Sign = sB64 & ":" & sExpire
End Function

'KɌĂ݂-------------------------------------------------------------
Public Sub vbc_BinaryJoint(JointA() As Byte, JointB() As Byte, retJoint() As Byte)
  retJoint = CStr(JointA) & CStr(JointB)
#If developmode2 Then
  Dim bStr As String, i As Long
  For i = 0 To UBound(retJoint)
    If retJoint(i) < 16 Then bStr = bStr & "0" & Hex(retJoint(i)) Else bStr = bStr & Hex(retJoint(i))
  Next
  Debug.Print bStr
#End If
End Sub

Public Function vbc_BASE64HashB64(sSourceBASE64 As String, retBinary() As Byte, retHashB64 As String) As Long
  Dim b64Length As Long, lret As Long, lLength As Long
  'vZ
  b64Length = Len(sSourceBASE64) / 4 * 3
  If Right(sSourceBASE64, 2) = "==" Then
    lLength = lLength - 2
  ElseIf Right(sSourceBASE64, 1) = "=" Then
    lLength = lLength - 1
  End If
  If b64Length <= 0 Then vbc_BASE64HashB64 = 1: Exit Function 'BASE64f[^Ȃ
  
  'BASE64fR[h
  ReDim retBinary(b64Length - 1) As Byte
  Debug.Print sSourceBASE64 & "" & b64Length & "TCYɃfR[h"
  lret = BASE64_DecryptText(retBinary(0), b64Length, sSourceBASE64, Len(sSourceBASE64))
  If lret = -1 Then vbc_BASE64HashB64 = 1: Exit Function 'fR[hG[
  Debug.Print "KKKKKKKKKKKKKKKKKKKKKKKK:" & retBinary(b64Length - 2)
  Debug.Print "l:" & b64Length & " - " & lLength & " /// " & lret
  ReDim Preserve retBinary(lret - 1) As Byte

  'MD5쐬
  'Debug.Print b64Length & "fR[ĥMD5"
  retHashB64 = vbc_GenerateMD5b64(retBinary())
End Function

'BASE64f[^̃nbV擾-----------------------------------------------
Public Function vbc_BASE64Hash(sSourceBASE64 As String, retBinary() As Byte, retMD5Binary() As Byte) As Long 'retMD5s64 As String) As Long '
  Dim b64Length As Long, lret As Long, lLength As Long
  'vZ
  b64Length = Len(sSourceBASE64) / 4 * 3
  If Right(sSourceBASE64, 2) = "==" Then
    lLength = lLength - 2
  ElseIf Right(sSourceBASE64, 1) = "=" Then
    lLength = lLength - 1
  End If
  If b64Length <= 0 Then vbc_BASE64Hash = 1: Exit Function 'BASE64f[^Ȃ
  
  'BASE64fR[h
  ReDim retBinary(b64Length - 1) As Byte
  Debug.Print sSourceBASE64 & "" & b64Length & "TCYɃfR[h"
  lret = BASE64_DecryptText(retBinary(0), b64Length, sSourceBASE64, Len(sSourceBASE64))
  If lret = -1 Then vbc_BASE64Hash = 1: Exit Function 'fR[hG[
  Debug.Print "KKKKKKKKKKKKKKKKKKKKKKKK:" & retBinary(b64Length - 2)
  Debug.Print "l:" & b64Length & " - " & lLength & " /// " & lret
  ReDim Preserve retBinary(lret - 1) As Byte
  
  
  Dim lLoop As Long, sDBG As String
  For lLoop = 0 To lret - 1
        sDBG = sDBG & Hex(retBinary(lLoop))
  Next
  Debug.Print "KE2 SOURCE(B64):" & sSourceBASE64
  Debug.Print "KE2 BINARY(H10):" & sDBG
  
  
  'MD5쐬
  ReDim retMD5Binary(15) As Byte
  'Debug.Print b64Length & "fR[ĥMD5"
  'retMD5s64 = vbc_GenerateMD5b64(retBinary())
  
  '[`FbN|Cg]b64LengthŃI[o[Ă̂C܂A
  '                  I[o[CO̕\KvɂȂ悤ȋC
  'MD5_BinaryGenerate retMD5Binary(0), retBinary(0), lret ' b64Length
  
  ReDim Preserve retBinary(b64Length - 1) As Byte
  MD5_BinaryGenerate retMD5Binary(0), retBinary(0), b64Length
  
  
  'For lret = 0 To UBound(retBinary)
  '  Debug.Print "RETB:" & Hex(retBinary(lret))
  'Next
End Function

'obt@mۂʂȃXy[XƉs̍폜-------------------------------------
Public Sub vbc_BlankDelete(CheckString As String)
  CheckString = Replace$(CheckString, vbLf, "")
  CheckString = Left$(CheckString, InStr(1, CheckString, vbNullChar) - 1)
End Sub

'_-----------------------------------------------------------------------
Public Function Generate_Random() As String
  Generate_Random = Int(Rnd() * 2147483640) & Int(Rnd() * 2147483640)
End Function

Public Function vbc_GenerateMD5b64(bSourceBinary() As Byte) As String
  Dim bMD5Binary(15) As Byte, sMD5 As String
  MD5_BinaryGenerate bMD5Binary(0), bSourceBinary(0), UBound(bSourceBinary) + 1
  
  sMD5 = String$(32, Chr$(0))
  BASE64_EncryptText sMD5, 32, bMD5Binary(0), 16: vbc_BlankDelete sMD5
  vbc_GenerateMD5b64 = sMD5

End Function
